<?php
   
    /*************************************************\
    **   Module     : DatsoGallery Ultimate Copy     **
    **   Copyright (C) 2006-2007  by Andrey Datso    **
	**   Version    : 1.2                            **
    **   Homepage   : http://www.datso.fr            **
    \*************************************************/  

    defined( '_VALID_MOS' ) or die( 'Restricted access.' );

?>

    <style type="text/css" media="screen">
    /*<![CDATA[*/
    @import "<?php echo $mosConfig_live_site; ?>/modules/mod_datsogallery_ultimate_copy/style.css";
    /*]]>*/
    </style>

<?php

    global $database, $gid, $mainframe, $mosConfig_live_site;
    
    $moduleclass   = $params->get( 'moduleclass' );
    $border_width  = $params->get( 'border_width' );
    $border_style  = $params->get( 'border_style' );
    $border_color  = $params->get( 'border_color' );
    $bg_color 	   = $params->get( 'bg_color' );
    $padding 	   = $params->get( 'padding' );
    $margin        = $params->get( 'margin' );
    $style 	       = $params->get( 'style', '' );
    $sort 	       = $params->get( 'sort' );
    $count 	       = $params->get( 'count' );
    $catid 	       = $params->get( 'catid' );
    $showimgtitle  = $params->get( 'showimgtitle' );
    $opacity 	   = $params->get( 'opacity' );
    $alignment     = $params->get( 'alignment' );

    $database->setQuery("select id from #__menu where link='index.php?option=com_datsogallery'");
    $rows2 = $database->loadObjectList();

    if (isset($rows2[0]->id)) {
    $Itemid = $rows2[0]->id;
    } else {
    $Itemid = "";
    }

    switch ($style) {
    case 'vert':
    $style = 'text-align:center';
    break;

    case 'horiz':
    $style = 'float:left';
    break;

    default:
    $style;
    break;
    }

    switch ($sort) {
	case 'lastcomment':
    $database->setQuery("select a.*, cc.cmtid "
	. " from #__datsogallery as a "
    . " inner join #__datsogallery_comments as cc "
	. " left join #__datsogallery_catg as ca on ca.cid = a.catid" . ( $catid ? " and ( catid in ( $catid ) )" : '' )
	. " where a.id = cc.cmtpic "
	. " and a.catid = ca.cid "
	. " and a.published = 1 "
	. " and a.approved = 1 "
    . " and ca.published = 1 "
	. " and ca.access <= $gid "
	. " order by cc.cmtid desc limit $count ");
    break;

	case 'lastadd':
    $database->setQuery("select * "
	. " from #__datsogallery as a "
    . " left join #__datsogallery_catg as ca on ca.cid = a.catid" . ( $catid ? " and ( catid in ( $catid ) )" : '' )
	. " where a.catid = ca.cid "
	. " and a.published = 1 "
	. " and a.approved = 1 "
    . " and ca.published = 1 "
	. " and ca.access <= $gid "
	. " order by a.id desc limit $count");
    break;

	case 'rating':
	$database->setQuery("select *, imgvotesum "
	. " as rating from #__datsogallery as a "
    . " left join #__datsogallery_catg as ca on ca.cid = a.catid" . ( $catid ? " and ( catid in ( $catid ) )" : '' )
	. " where a.catid = ca.cid "
	. " and a.imgvotes > 0 "
	. " and a.published = 1 "
	. " and a.approved = 1 "
    . " and ca.published = 1 "
	. " and ca.access <= $gid "
	. " order by rating desc limit $count");
    break;

    case 'popular':
    $database->setQuery("select * "
	. " from #__datsogallery as a "
    . " left join #__datsogallery_catg as ca on ca.cid = a.catid" . ( $catid ? " and ( catid in ( $catid ) )" : '' )
	. " where a.catid = ca.cid "
	. " and a.published = 1 "
	. " and a.approved = 1 "
    . " and ca.published = 1 "
	. " and ca.access <= $gid "
	. " order by imgcounter desc limit $count");
    break;

	default:
    $database->setQuery("select * "
	. " from #__datsogallery as a "
    . " left join #__datsogallery_catg as ca on ca.cid = a.catid" . ( $catid ? " and ( catid in ( $catid ) )" : '' )
	. " where a.catid = ca.cid "
	. " and a.published = 1 "
	. " and a.approved = 1 "
    . " and ca.published = 1 "
	. " and ca.access <= $gid "
	. " order by rand() desc limit $count");
    break;
    }

    $rows1 = $database->loadObjectList();

    require($mainframe->getCfg( 'absolute_path' )."/administrator/components/com_datsogallery/config.datsogallery.php");

    $thumbnailpath  = $mosConfig_live_site.$ad_paththumbs."/";

    if(count($rows1)){
    foreach($rows1 as $row1){
    $img = "$thumbnailpath$row1->imgthumbname";
    if ($opacity == 1) {
    echo '<div id="thumb" style="'.$style.'">';
    } else {
    echo '<div style="'.$style.'">';
    }
    echo '<a href="'.sefRelToAbs("index.php?option=com_datsogallery&Itemid=$Itemid&func=detail&catid=$row1->catid&id=$row1->id").'">';
    echo '<img src='.$img.' style="border:'.$border_width.'px;
    border-style:'.$border_style.';border-color:'.$border_color.';
    padding:'.$padding.'px;margin:'.$margin.'px;background-color:'.$bg_color.'"></a>';
    if ($showimgtitle == 1) {
    echo '<br /><div align="center">'.$row1->imgtitle.'</div><p /></div>';
    } else {
    echo '</a></div>';
    }
    }
    } else {
    echo "There are no pictures.";
    }
?>
