<?php

    /************************************************\
    **  DatsoPic - Inserting ThumbPics by Id to     **
    **  Content pages from DatsoGallery component   **
    **  Author     : Andrey Datso                   **
	**  Version    : 1.2                            **
    **  Date       : 04.03.2007                     **
    **  Homepage   : http://www.datso.net           **
    **  Copyright  : (C) 2007 by Andrey Datso       **
    **  Released Under GNU GPL Public License       **
    \************************************************/

    /************************************************\
    ** DatsoPic Plugin Usage:                      **
    ** 1.  {datsopic id=id} - Dedault left side     **
    ** 2.  {datsopic id=id align=left}              **
    ** 3.  {datsopic id=id align=right}             **
    \************************************************/

    defined( '_VALID_MOS' ) or die( 'Restricted access.' );
    ?>
    <style type="text/css">
    /*<![CDATA[*/
    .dgpic {
    float:left;
    background:#FFF;
    border:1px solid #BDBDBD;
    margin:5px;
    padding:1px
    }

    .dgpic_left {
    float:left;
    background:#FFF;
    border:1px solid #BDBDBD;
    margin:5px;
    padding:1px
    }

    .dgpic_right {
    float:right;
    background:#FFF;
    border:1px solid #BDBDBD;
    margin:5px;
    padding:1px
    }

    .dgpic_capt {
    font-size:9px;
    font-weight:400;
    color:#FFF;
    border-top:1px solid #FFF;
    background:#BDBDBD;
    text-align: center;
    }

    html* .dgpic_capt {
    font-size:9px;
    font-weight:400;
    color:#FFF;
    border-top:none;
    border-top: none;
    background:#BDBDBD;
    text-align: center;
    }
    /*]]>*/
    </style>
    <?php
    $_MAMBOTS->registerFunction( 'onPrepareContent', 'botDatsoPic' );

    function botDatsoPic( $published, &$row, &$params, $page=0 ) {

    $regex = "#{datsopic*(.*?) align=(.*?)}#s";

    if (!$published) {
	$row->text = preg_replace( $regex, '', $row->text );
	return true;
	}

    $row->text = preg_replace_callback( $regex, 'botDatsoPic_replacer', $row->text );
    return true;
    }

    function botDatsoPic_replacer( &$matches ) {
    global $database, $mosConfig_live_site, $mosConfig_absolute_path;
    require($mosConfig_absolute_path."/administrator/components/com_datsogallery/config.datsogallery.php");
    $thumbnailpath  = $mosConfig_live_site.$ad_paththumbs."/";

    $id = str_replace('id=','',$matches[1]);
    $align = str_replace('align=','',$matches[2]);

    $query1 = "SELECT id FROM #__menu WHERE link = 'index.php?option=com_datsogallery'";
    $database->setQuery( $query1 );
    $rows = $database->loadObjectList();

    if (isset($rows[0]->id)) {
    $Itemid = $rows[0]->id;
    } else {
    $Itemid = "";
    }


    $query2 = "SELECT id,imgthumbname,imgtitle FROM #__datsogallery WHERE id='$id'";
    $database->setQuery( $query2 );
    $row = $database->loadRow();

    return "<div class='dgpic_$align'><a href='".sefRelToAbs("index.php?option=com_datsogallery&Itemid=$Itemid&func=detail&id=$row[0]")."'>
    <img src='$thumbnailpath$row[1]' border='0' title='$row[2]' alt='$row[2]' /></a>
    <div class='dgpic_capt'>$row[2]</div></div><span style='display:none'>DatsoPic 1.2 &copy; 2007 by Andrey Datso</span>";
    }

?>