<?php
  defined('_JEXEC') or die('Restricted access');
  $header="<link rel='stylesheet' href='".JURI::base()."components/com_datsogallery/libraries/rater/rater.css' type='text/css' />\n";
  $mainframe->addCustomHeadTag($header);
  GalleryHeader();
  switch($sorting) {
    case 'find':
      $db->setQuery("select * "
      ." from #__datsogallery as a, #__datsogallery_catg "
      ." as ca where a.catid=ca.cid "
      ." and (( a.imgtitle like '%$sstring%' ) || ( a.imgtext like '%$sstring%' )) "
      ." and a.published='1' "
      ." and a.approved=1 "
      ." and ca.published='1' "
      ." and ca.access<=".$user->get('aid')." "
      ." order by a.id desc"
      );
      $tl_title=_DG_SEARCH_RESULTS." $sstring ";
      $pw_title=_DG_SEARCH_RESULTS." $sstring ";
      break;
    case 'lastcomment':
      $db->setQuery("select a.*, cc.cmtid "
      ." from #__datsogallery as a, #__datsogallery_comments as cc, "
      ." #__datsogallery_catg as ca "
      ." where a.id=cc.cmtpic "
      ." and a.catid=ca.cid "
      ." and cc.cmtid=(select max(ab.cmtid) "
      ." from #__datsogallery_comments as ab "
      ." where a.id=ab.cmtpic) "
      ." and a.published='1' "
      ." and a.approved=1 "
      ." and ca.published='1' "
      ." and ca.access<=".$user->get('aid')." "
      ." group by a.id order by cc.cmtid desc limit $ad_toplist"
      );
      $tl_title=" $ad_toplist "._DG_LAST_COMMENT_PIC;
      $pw_title=_DG_LAST_COMMENTED;
      break;
    case 'lastadd':
      $db->setQuery("select * "
      ." from #__datsogallery as a, #__datsogallery_catg "
      ." as ca where a.catid=ca.cid "
      ." and a.published=1 "
      ." and a.approved=1 "
      ." and ca.published=1 "
      ." and ca.access<=".$user->get('aid')." "
      ." order by a.id desc limit $ad_toplist"
      );
      $tl_title=" $ad_toplist "._DG_NEW_PIC;
      $pw_title=_DG_LAST_ADDED;
      break;
    case 'rating':
      $db->setQuery("select *, imgvotesum "
      ." as rating from #__datsogallery "
      ." as a, #__datsogallery_catg "
      ." as ca where a.catid=ca.cid "
      ." and a.imgvotes > 0 "
      ." and a.published = 1  "
      ." and a.approved = 1  "
      ." and ca.published = 1  "
      ." and ca.access<=".$user->get('aid')." "
      ." order by rating desc limit $ad_toplist"
      );
      $tl_title=" $ad_toplist "._DG_BEST_RATED_PIC;
      $pw_title=_DG_TOP_RATED;
      break;
    case 'owner':
      $db->setQuery("select username from #__users where id = '$op'");
      $imgowner=$db->loadResult();
      $db->setQuery("select * "
      ." from #__datsogallery as a, #__datsogallery_catg "
      ." as ca where a.catid=ca.cid "
      ." and a.published=1 "
      ." and a.owner = '$imgowner' "
      ." and a.approved=1 "
      ." and ca.published=1 "
      ." and ca.access<=".$user->get('aid')." "
      ." order by a.id desc limit $ad_toplist"
      );
      $tl_title=" $ad_toplist "._DG_NEW_PIC." "._DG_FROM_USER." $imgowner";
      $pw_title=" $ad_toplist "._DG_NEW_PIC." "._DG_FROM_USER." $imgowner";
      break;
    default:
      $db->setQuery("select * "
      ." from #__datsogallery "
      ." as a, #__datsogallery_catg "
      ." as ca where a.catid=ca.cid "
      ." and a.published=1 "
      ." and a.approved=1 "
      ." and ca.published=1 "
      ." and ca.access<=".$user->get('aid').""
      ." order by imgcounter desc limit $ad_toplist"
      );
      $tl_title=" $ad_toplist "._DG_MOST_VIEWED_PIC;
      $pw_title=_DG_MOST_VIEWED;
      break;
  }
  $rows=$db->loadObjectList();
  $mainframe->setPageTitle($pw_title);
  //$mainframe->AppendPathway($pw_title);
?>
<table width='100%' border='0' cellspacing='1' cellpadding='10'>
    <tr><td colspan='2' class='sectiontableheader' width='100%'><?php echo $tl_title; ?></td>
    <?php
      $rowcounter=0;
      if(count($rows)) {
        foreach($rows as $row) {
        ?>
	</tr>
    <tr class='sectiontableentry1'>
    <td align='center'>
    <a href='<?php echo JRoute::_("index.php?option=com_datsogallery&amp;func=detail&amp;catid=".$row->catid."&amp;id=".$row->id."&amp;Itemid=".$Itemid); ?>'>
    <img src='<?php echo $thumbnailpath.$row->imgthumbname; ?>' style='<?php echo $ad_imgstyle; ?>' alt='' /></a>
    </td>
    <td width='100%' valign='top'><strong><?php echo $row->imgtitle; ?></strong>
    <span class="small">
                  <?php
                    if($ad_showdetail)
                      $picdate=strftime("%d.%m.%Y %H:%M",$row->imgdate);
                    echo "<br /><strong>"._DG_DATE_ADD."</strong>: $picdate ";
                    echo "<br /><strong>"._DG_HITS."</strong>: $row->imgcounter ";
                    if($ad_showrating) {
                      if($row->imgvotes>0) {
                        $fimgvotesum=number_format(intval($row->imgvotesum)/intval($row->imgvotes),2)*20;
                      }
                      else{
                        $fimgvotesum="0";
                      }
                      echo "<br /><strong>"._DG_RATING."</strong>:
                      <span class='inline-rating'>
                      <ul class='star-rating small-star' style='width: 50px'>
                      <li class='current-rating' style='width: ".$fimgvotesum."%'></li>
                      <li class='star' style='width: 20%'></li>
                      <li class='star' style='width: 40%'></li>
                      <li class='star' style='width: 60%'></li>
                      <li class='star' style='width: 80%'></li>
                      <li class='star' style='width: 100%'></li>
                      </ul>
                      </span> / $row->imgvotes";
                    }
                    if($ad_showcomment) {
                      $db->setQuery("select cmtid from #__datsogallery_comments where cmtpic='".$row->id."'");
                      $comments_result=$db->query();
                      $comments=mysql_num_rows($comments_result);
                      echo "<br /><strong>"._DG_COMMENTS."</strong>: $comments";
                    }
                  ?>
    </span>
	</td>
                  <?php
                    $rowcounter++;
                  }
                }
              ?>
    </tr>
</table>
