<?php
/**
* Tab for Community Builder User Profiles 
* to display the pictures the user has up-
* loaded in DatsoGallery
* 
* Author: Eric Foster, Armin Hornung
* Date: May 2006
* Released under GPL
**/
class getDatsoTab extends cbTabHandler {
	function getDatsoTab() {
		$this->cbTabHandler();
		}
/**
 * Creates and returns the header of the Gallery tab
 * conatining No. of images, and upload-link if configured 
 */
  function getHeader($own, $total, $Itemid){
  	$return = '';
  	
  	if (intval($total) == 0){
  		$return.="<p>The user has uploaded no images to the Gallery.";
	}
	else {
  		$return.= "<p>Total number of images: <strong>". $total ."</strong><br>";
	}
  		
  		
	if ($own)
		$return .="Upload images from your <a href=\"index.php?option=com_datsogallery&Itemid=$Itemid&func=userpanel\">Gallery User Panel</a>!";
		
  	
  	
        $return.= "</p>";
        return $return;
  }
  /**
   * Helper function from Datsogallery, creates the path for categories
   */
  function ShowCategoryPath ($cat){
	global $database, $mosConfig_lang;
	$cat=intval( $cat );
	$parent_id=1000;
	while ( $parent_id ){
        // read name and parent_id
        $query="select * from #__datsogallery_catg where cid=$cat";
        $database->setQuery( $query );
        $result=$database->query();
        $parent_id=@mysql_result( $result, 0, 'parent' );
        $name=@mysql_result( $result, 0, 'name' );
        // write path
        if ( empty( $path ) ) {
            $path=$name;
            }
        else {
            $path=$name . ' &gt; ' . $path;
            }
        // next looping
        $cat=$parent_id;
    }
	return $path . " ";
  }
  
/**
 * Main function, displays the Gallery-Tab in Community Builder
 */	
  function getDisplayTab($tab,$user,$ui) {

	global $database,$mosConfig_live_site, $mosConfig_absolute_path, $mosConfig_lang, $my;
	
	// Component Path:
	$datso_config_path =$mosConfig_absolute_path . "/administrator/components/com_datsogallery/config.datsogallery.php"; 
	if(file_exists($datso_config_path)){
		require_once($mosConfig_absolute_path . "/administrator/components/com_datsogallery/class.datsogallery.php" );	
		require_once($datso_config_path);
	}
	else
		return "Error: Config file of Datsogallery not found. Is the component in version 1 (non-beta) installed?";
 
 
    $picturepath=$mosConfig_live_site . $ad_pathimages . "/";
    $thumbnailpath=$mosConfig_live_site . $ad_paththumbs . "/";

    $uid=intval( mosGetParam( $_REQUEST, "uid", 0 ) );
    
    // ItemId for Gallery-links:
    $database->setQuery("select id from #__menu where link='index.php?option=com_datsogallery' AND published=1");
	$Itemid=$database->loadResult();

	// Language file inclusion
    if (file_exists($mosConfig_absolute_path."/components/com_datsogallery/language/".$mosConfig_lang.".php")) 
	    include_once($mosConfig_absolute_path."/components/com_datsogallery/language/".$mosConfig_lang.".php");
	else 
		include_once($mosConfig_absolute_path."/components/com_datsogallery/language/english.php");
	

	
	$params = $this->params;
	
	// String to return
	$return="";
	if($tab->description != null) 
		$return .= "\t\t<div class=\"tab_Description\">".unHtmlspecialchars(getLangDefinition($tab->description))."</div>\n";
		
	// Determine # of pics for pagination	
    $database->setQuery(
            "SELECT count(id) FROM #__datsogallery as a " 
                . "\n  WHERE a.published = '1'"
				. "\n AND a.owner = '$user->username'"
				. "\n AND a.approved = 1");

    $total=$database->loadResult();
    
    // Hide tab if no pics and it is configured to hide:
    if (($total==0) && ($params->get('showEmptyTab','0')==0))
    	return null;
    
    $startpage=1;
    
    // Pagination:
    $picsperpage = $params->get('picsperpage','');
    if (!$picsperpage)
    	$picsNumber = $ad_perpage;
    else 
    	$picsNumber = $picsperpage;
	
    $pagingParams = $this->_getPaging(array(),array("datsopics_"));
    if ($pagingParams["datsopics_limitstart"] === null) 
    	$pagingParams["datsopics_limitstart"] = "0";
    if ($picsNumber > $total) 
    	$pagingParams["datsopics_limitstart"] = "0";
	    
	   
    // Include Header (Information) on first page:
    $showUploadLink = (($params->get('uploadLinkEnabled', '1')==1) && ($user->id == $my->id));
    if ($pagingParams["datsopics_limitstart"] == "0")
		$return .= $this->getHeader($showUploadLink, $total, $Itemid);
	
	// Start of pics table:	
    $return.= "<table  class='sectiontableentry2' width='100%' border='0' cellspacing='1' cellpadding='4'>";
    
    // Order images by:
    $sortby=$params->get('sortBy','catid ASC');
    if ($sortby =="rating"){
    	$database->setQuery(
        "SELECT *, ROUND(a.imgvotesum/a.imgvotes, 2) as rating FROM #__datsogallery as a" 
            . "\n  WHERE a.published = '1' " . " AND a.approved = 1"
            . "\n AND a.owner = '$user->username'"
            . "\n ORDER BY rating DESC" 
			. "\n LIMIT ".($pagingParams["datsopics_limitstart"]?$pagingParams["datsopics_limitstart"]:"0").",".$picsNumber);
    } 
    else {
    	$sortby = "a.".$sortby;
	    // Main query:   
    	$database->setQuery(
        	"SELECT * FROM #__datsogallery as a " 
            . "\n  WHERE a.published = '1' " . " AND a.approved = 1"
            . "\n AND a.owner = '$user->username'"
            . "\n ORDER BY ".$sortby
			. "\n LIMIT ".($pagingParams["datsopics_limitstart"]?$pagingParams["datsopics_limitstart"]:"0").",".$picsNumber);
    }

    $rows=$database->loadObjectList();
    $recordcount=count($rows);
    $return.= "<tr>";
    $rowcounter=0;
if ($recordcount >0) {
    foreach ( $rows as $row1 ){
    	if ( ($rowcounter % 3 == 0) AND ($rowcounter <> 0) )
        	$return.="</tr><tr>";

        $return.= "<td class='sectiontableentry1' width='34%' align='center' valign='bottom'>";
		$return.= "<a href='index.php?option=com_datsogallery&Itemid=$Itemid&func=detail&id=$row1->id'><img src='$thumbnailpath$row1->imgthumbname' border='0'></a><br />";
		$return .= "<b>$row1->imgtitle</b>";
		
		// Display Category path:
        if ($params->get('showCategory','1')==1){
			$Category = $this->ShowCategoryPath($row1->catid);
			$return .= "<br />in: $Category";
		}
		
		// Display Details and rating:
        if ( $ad_showdetail )
            $return.= "<br />"._DG_HITS.": $row1->imgcounter";
        if ( $ad_showrating ){
            if ( $row1->imgvotes > 0 ){
                    $fimgvotesum=number_format( $row1->imgvotesum / $row1->imgvotes, 2, ",", "." );
                    $frating="$fimgvotesum ($row1->imgvotes Votes)";
			}
            else {
                $frating=_DG_NO_VOTES;
			}

            $return.="<br />"._DG_RATING.": $frating";
		}
        
        // Comments:
        if ( $ad_showcomment ){

		# Check how many comments exist
            $database->setQuery( "SELECT cmtid FROM #__datsogallery_comments WHERE cmtpic='$row1->id'" );
            $comments_result=$database->query();
            $comments=mysql_num_rows( $comments_result );
            $return.= "<br />"._DG_COMMENT.": $comments";
		}

        $return.= "</td>";
        $rowcounter++;
	}
}

    if ( $rowcounter % 3 <> 0 ){
    	for ( $i=1; $i <= (3 - ($rowcounter % 3)); $i++ ) {
			$return.= "<td class='sectiontableentry1' width='34%' valign='top'> </td>";
		}
	}

    $return.= "</tr></table>";
    
    // Pagination, if configured to show:
    $showPagination = ($params->get('pagination','1')=='1');
	if ($showPagination &&($picsNumber < $total)) {
		$return .= "<div style='width:95%;text-align:center;'>"
		.$this->_writePaging($pagingParams,"datsopics_",$picsNumber,$total)
		."</div>";
	}
	
	      
	return $return;
	}
}
?>