<?php
/**
 * JoomlaSEF extension
 *
 * @author      Mehdi ArtWork
 * @copyright   Mehdi ArtWork, http://www.tunisiaclubbing.com
 * @package     ext_com_datsogallery
 * @version     2.0.0
 */

if (!defined('_VALID_MOS')) die('KISITLI ALAN');

class  SefExt_com_datsogallery extends SefExt
{

     function KategoriYolu($catid) {
        global $database;

        $params 	= SEFTools::getExtParams('com_datsogallery');
        $kats 		= $params->get('Kategoriler', '2');
        $katid 		= $params->get('kategoriID', '0');

        $kategorilerArray = array();


        if($kats == '0')    $catid = 0;
        while ($catid > 0) {

		$database->setQuery("SELECT `name`, `parent` FROM `#__datsogallery_catg` WHERE `cid` = $catid");
        $row = $database->loadRow();

		$kategori_adi = ($katid != '0' ? $catid.'-' : '').$row[0];
        array_unshift ($kategorilerArray, $kategori_adi);

		$catid = $row[1];

        if($kats == '1')    break;
        }
        return $kategorilerArray;

    }

    function ResimYolu($id) {
        global $database;

        $database->setQuery("SELECT `imgtitle`, `catid` FROM `#__datsogallery` WHERE `id` = $id");
        $row = $database->loadRow();
        $resimler = $this->KategoriYolu($row[1]);

        $params = SEFTools::getExtParams('com_datsogallery');
        $resimid = $params->get('id', '0');

        $resim_adi = ($resimid != '0' ? $id.'-' : '').$row[0];
        array_push($resimler, $resim_adi);

        return $resimler;
    }

    function create(&$string) {
        global $mosConfig_absolute_path, $mosConfig_lang, $mosConfig_sitename, $mosConfig_live_site;
		 $vars = $string->getQuery(true);

		if( file_exists($mosConfig_absolute_path.'/components/com_datsogallery/language/'.$mosConfig_lang.'.php') )
        require_once($mosConfig_absolute_path.'/components/com_datsogallery/language/'.$mosConfig_lang.'.php');
        if( ($mosConfig_lang != 'english') && file_exists($mosConfig_absolute_path.'/components/com_datsogallery/language/english.php') )
        require_once($mosConfig_absolute_path.'/components/com_datsogallery/language/english.php');

        // Degiskenleri ikar
        extract($vars);
        $title = array();
        $title[] =JoomSEF::_getMenuTitle(@$option, @$task, @$Itemid);


        if( isset($func) ) {
            switch( $func ) {
				
				case 'viewcategory':
					$title = array_merge($title, $this->KategoriYolu($catid));
					break;
				
                case 'detail':
                    if( isset($id))
                    $title = array_merge($title, $this->ResimYolu($id));
                    break;

				case 'special':
						if( isset($sorting) ) {
							switch ($sorting){
								case 'rating':
									$title[] = _DG_TOP_RATED;
									break;

								case 'lastadd':
									$title[] = _DG_LAST_ADDED;
									break;

								case 'lastcomment':
									$title[] = _DG_LAST_COMMENTED;
									break;

								}

							} else {
                    	$title[] = _DG_MOST_VIEWED;
						}
                    break;

 				case 'userpannel':
                    $title[] = _DG_USER_PANEL;
                    break;

 				case 'showupload':
                    $title[] = _DG_UPLOAD_NEW_PIC;
                    break;

 				case 'editpic':
                    $title[] = _DG_NSDES;
                    break;

 				case 'deletepic':
                    $title[] = _DG_DELETEPIC_TB;
                    break;

                     return $string;
            }
        }

        if (count($title) > 0) {
			$string = JoomSEF::_sefGetLocation($string, $title, @$task, @$limit, @$limitstart, @$lang);
        }

        return $string;
    }
}

?>
