<?php

    /************************************\
    **  DatsoGallery plugin for Joomap  **
    **  Version: 1.1                    **
    **  Author: Andrey Datso            **
    **  Homepage: www.datso.fr          **
    **  Updated by Kevin Hayne          **
    \************************************/

    defined( '_VALID_MOS' ) or die( 'Restricted access.' );

    $tmp = new Joomap_DatsoGallery;
    JoomapPlugins::addPlugin( $tmp );

    class Joomap_DatsoGallery {

	    function isOfType( &$joomla, &$parent ) {
	    	if( strpos($parent->link, 'option=com_datsogallery') ) {
	    		return true;
	    	}
	    return false;
	    }
	
	    function &getTree( &$joomap, &$parent ) {
	    	global $database;
	
		    $list = array();
		
		    $database->setQuery("select cid, name, parent from #__datsogallery_catg order by ordering");
		    $cats = $database->loadObjectList();
	
		    foreach($cats as $cat) {
			    $node = new stdclass;
			    $node->id   = $parent->id;
			    $node->name = $cat->name;
			    $node->link = $parent->link.'&amp;Itemid='.$parent->id.'&amp;func=viewcategory&amp;catid='.$cat->cid;
			    $node->tree = array();
			    $node->pid = $cat->parent;
			
			    $list[$cat->cid] = $node;
		    }
	    
			foreach( $list as $id => $cat ) {										// move children into their parent nodes
				if( $cat->pid > 0  && isset($list[$cat->pid]) ) {
					$list[ $cat->pid ]->tree[] = &$list[$id];
				}
			}
			
			foreach( $list as $id => $cat ) {										// remove children from top tree
				if( $cat->pid > 0 ) {
					unset( $list[$id] );
				}
			}
	
	    return $list;
	    }
    }

?>