<?php
	/***************************************************\
	**   DatsoGallery - A Joomla! Gallery Component    **
	**   Copyright (C) 2006-2008  by Andrey Datso      **
	**   Version    : 1.6                              **
	**   Homepage   : http://www.datso.fr              **
	**   License    : Copyright, don't distribute      **
	\***************************************************/

    defined ('_VALID_MOS') or die('Direct Access to this location is not allowed.');

    function dgImageCreate($srcfile, $destfile, $max_width, $max_height, $quality, $ad_crsc = false) {
    list ($src_width, $src_height, $type) = getimagesize($srcfile);
    switch ($type) {
    case 1 : $srcimage = imagecreatefromgif($srcfile); break;
    case 2 : $srcimage = imagecreatefromjpeg($srcfile); break;
    case 3 : $srcimage = imagecreatefrompng($srcfile); break;
    default : echo _DG_FOUR_ERR;
    return false;
    }
    if ($ad_crsc == true) {
    if ($src_width > $src_height ) {
    $image_width = $max_width;
    $image_height = floor($src_height * ($max_width / $src_width));
    } else if ($src_width < $src_height ) {
    $image_height = $max_height;
    $image_width = floor($src_width * ($max_height / $src_height));
    } else {
    $image_width = $max_height;
    $image_height = $max_height;
    }
    if (!@$destimage = imagecreatetruecolor($image_width, $image_height)) {
    return false;
    }
    if (!@fastimagecopyresampled($destimage, $srcimage, 0, 0, 0, 0, $image_width, $image_height, $src_width, $src_height)) {
    return false;
    }
    } else if ($ad_crsc == false) {
    $ratio = $max_width / $max_height;
    if ($ratio > 1) {
    if ($src_width > $src_height) {
    $image_width = $max_width;
    $image_height = ceil($max_width * ($src_height / $src_width));
    if ($image_height > $max_width) {
    $image_height = $max_width;
    $image_width = ceil($max_width * ($src_width / $src_height));
    }
    } else {
    $image_height = $max_width;
    $image_width = ceil($max_width * ($src_height / $src_width));
    if ($image_width > $max_width) {
    $image_width = $max_width;
    $image_height = ceil($max_width * ($src_height / $src_width));
    }
    $off_h = ($src_height - $src_width) / 2;
    }
    if (!@$destimage = imagecreatetruecolor($max_width, $max_height)) {
    return false;
    }
    if (!@fastimagecopyresampled($destimage, $srcimage, 0, 0, 0, $off_h, $image_width, $image_height, $src_width, $src_height)) {
    return false;
    }
    } else {
    if ($src_width > $src_height) {
    $off_w = ($src_width - $src_height) / 2;
    $off_h = 0;
    $src_width = $src_height;
    } else if ($src_height > $src_width) {
    $off_w = 0;
    $off_h = ($src_height - $src_width) / 2;
    $src_height = $src_width;
    } else {
    $off_w = 0;
    $off_h = 0;
    }
    if (!@$destimage = imagecreatetruecolor($max_width, $max_height)) {
    return false;
    }
    if (!@fastimagecopyresampled($destimage, $srcimage, 0, 0, $off_w, $off_h, $max_width, $max_height, $src_width, $src_height)) {
    return false;
    }
    }
    }
    @imagedestroy($srcimage);
    if (!@imageantialias($destimage, true)) {
    return false;
    }
    switch ($type) {
    case 1 : imagegif($destimage, $destfile); break;
    case 2 : imagejpeg($destimage, $destfile, $quality); break;
    case 3 : imagepng($destimage, $destfile); break;
    default : echo _DG_FOUR_ERR;  // .   .
    return false;
    }
    @imagedestroy($destimage);
    return true;
    }

    function fastimagecopyresampled (&$dst_image, $src_image, $dst_x, $dst_y, $src_x, $src_y, $dst_w, $dst_h, $src_w, $src_h, $quality = 3) {
    if (empty($src_image) || empty($dst_image) || $quality <= 0) { return false; }
    if ($quality < 5 && (($dst_w * $quality) < $src_w || ($dst_h * $quality) < $src_h)) {
    $temp = imagecreatetruecolor ($dst_w * $quality + 1, $dst_h * $quality + 1);
    imagecopyresized ($temp, $src_image, 0, 0, $src_x, $src_y, $dst_w * $quality + 1, $dst_h * $quality + 1, $src_w, $src_h);
    imagecopyresampled ($dst_image, $temp, $dst_x, $dst_y, 0, 0, $dst_w, $dst_h, $dst_w * $quality, $dst_h * $quality);
    imagedestroy ($temp);
    } else imagecopyresampled ($dst_image, $src_image, $dst_x, $dst_y, $src_x, $src_y, $dst_w, $dst_h, $src_w, $src_h);
    return true;
    }


    function bb_decode ($text) {
    global $mosConfig_live_site;
    $gallerypath = $mosConfig_live_site . "/components/com_datsogallery";
	$text = nl2br($text);
	static $bbcode_tpl = array();
	static $patterns = array();
	static $replacements = array();
	if ((strpos($text, "[") === false || strpos($text, "]") === false)) {
	return $text;
	}
	$text = str_replace("[b]", '<b>', $text);
	$text = str_replace("[/b]", '</b>', $text);
	$text = str_replace("[u]", '<u>', $text);
	$text = str_replace("[/u]", '</u>', $text);
	$text = str_replace("[i]", '<i>', $text);
	$text = str_replace("[/i]", '</i>', $text);
    $text = str_replace("[B]", '<b>', $text);
	$text = str_replace("[/B]", '</b>', $text);
    $text = str_replace("[U]", '<u>', $text);
	$text = str_replace("[/U]", '</u>', $text);
    $text = str_replace("[I]", '<i>', $text);
	$text = str_replace("[/I]", '</i>', $text);
    $text = preg_replace("/\[quote\](.*?)\[\/quote\]/si", ' <blockquote><p>\\1</p></blockquote>', $text);
    $text = preg_replace("/\[list\](.+?)\[\/list\]/is", '<ul class="listbullet">[*]$1</ul>' ,$text);
    $text = preg_replace("/\[list=1\](.+?)\[\/list\]/is", '<ul class="listdecimal">$1</ul>' ,$text);
    $text = preg_replace("/\[list=i\](.+?)\[\/list\]/s", '<ul class="listlowerroman">$1</ul>' ,$text);
    $text = preg_replace("/\[list=I\](.+?)\[\/list\]/s", '<ul class="listupperroman">$1</ul>' ,$text);
    $text = preg_replace("/\[list=a\](.+?)\[\/list\]/s", '<ul class="listloweralpha">$1</ul>' ,$text);
    $text = preg_replace("/\[list=A\](.+?)\[\/list\]/s", '<ul class="listupperalpha">$1</ul>' ,$text);
    $text = str_replace("[*]", "<li>", $text);
	$text = str_replace("[sm1]", ' <img src="'.$gallerypath.'/images/bbcode/smile.gif" alt="Smile" border="0"> ', $text);
	$text = str_replace("[sm2]", ' <img src="'.$gallerypath.'/images/bbcode/grin.gif" alt="Grin" border="0"> ', $text);
	$text = str_replace("[sm3]", ' <img src="'.$gallerypath.'/images/bbcode/tongue.gif" alt="Tongue" border="0"> ', $text);
	$text = str_replace("[sm4]", ' <img src="'.$gallerypath.'/images/bbcode/wink.gif" alt="Wink" border="0"> ', $text);
	$text = str_replace("[sm5]", ' <img src="'.$gallerypath.'/images/bbcode/waii.gif" alt="Waii" border="0"> ', $text);
	$text = str_replace("[sm6]", ' <img src="'.$gallerypath.'/images/bbcode/unhappy.gif" alt="Unhappy" border="0"> ', $text);
	$text = str_replace("[sm7]", ' <img src="'.$gallerypath.'/images/bbcode/surprised.gif" alt="Surprised" border="0"> ', $text);
	$text = str_replace('&', '&amp',$text);
	if (!count($bbcode_tpl)) {
	$bbcode_tpl['url'] = '<span class="bblink"><a href="{URL}" target="_blank">{DESCRIPTION}</a></span>';
	$bbcode_tpl['email'] = '<span class="bblink"><a href="mailto:{EMAIL}">{EMAIL}</a></span>';
	$bbcode_tpl['url1'] = str_replace('{URL}', '\\1\\2', $bbcode_tpl['url']);
	$bbcode_tpl['url1'] = str_replace('{DESCRIPTION}', '\\1\\2', $bbcode_tpl['url1']);
	$bbcode_tpl['url2'] = str_replace('{URL}', 'http://\\1', $bbcode_tpl['url']);
	$bbcode_tpl['url2'] = str_replace('{DESCRIPTION}', '\\1', $bbcode_tpl['url2']);
	$bbcode_tpl['url3'] = str_replace('{URL}', '\\1\\2', $bbcode_tpl['url']);
	$bbcode_tpl['url3'] = str_replace('{DESCRIPTION}', '\\3', $bbcode_tpl['url3']);
	$bbcode_tpl['url4'] = str_replace('{URL}', 'http://\\1', $bbcode_tpl['url']);
	$bbcode_tpl['url4'] = str_replace('{DESCRIPTION}', '\\2', $bbcode_tpl['url4']);
	$bbcode_tpl['email'] = str_replace('{EMAIL}', '\\1', $bbcode_tpl['email']);
	$patterns[1] = "#\[url\]([a-z]+?://){1}([a-z0-9\-\.,\?!%\*_\#:;~\\&$@\/=\+\(\)]+)\[/url\]#si";
	$replacements[1] = $bbcode_tpl['url1'];
	$patterns[2] = "#\[url\]([a-z0-9\-\.,\?!%\*_\#:;~\\&$@\/=\+\(\)]+)\[/url\]#si";
	$replacements[2] = $bbcode_tpl['url2'];
	$patterns[3] = "#\[url=([a-z]+?://){1}([a-z0-9\-\.,\?!%\*_\#:;~\\&$@\/=\+\(\)]+)\](.*?)\[/url\]#si";
	$replacements[3] = $bbcode_tpl['url3'];
	$patterns[4] = "#\[url=([a-z0-9\-\.,\?!%\*_\#:;~\\&$@\/=\+\(\)]+)\](.*?)\[/url\]#si";
	$replacements[4] = $bbcode_tpl['url4'];
	$patterns[5] = "#\[email\]([a-z0-9\-_.]+?@[\w\-]+\.([\w\-\.]+\.)?[\w]+)\[/email\]#si";
	$replacements[5] = $bbcode_tpl['email'];
	}
	$text = preg_replace($patterns, $replacements, $text);
	return $text;
	}

    function removeFile($srcFilename, $srcFilePath) {
	$removeFilename = $srcFilePath . '/' . $srcFilename;
	if (unlink($removeFilename)) {
	return true;
	} else {
	return false;
	}
	}

?>