<?php

// mod_dgcomment_latest.php,
// Version : v0.1 - 03/08/06
// Author : Fly06 
// Contact : http://forum.joomlafacile.com/
// Licence : Released under GPL
// The "GNU General Public License" (GPL) is available at
// http://www.gnu.org/copyleft/gpl.html.

defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );

// RECUPERATION DES PARAMETRES
$number = intval(($params->get( 'number' )));
$moduleclasssfx = $params->get( 'moduleclass_sfx' );
$max = intval($params->get( 'max_length' ));
$customFormatStr = $params->get( 'custom_format_string' );
$nocomment = $params->get( 'no_comment' );
$setlocaletimeto = $params->get( 'set_locale_time_to' );
$textlink = intval($params->get( 'text_link' , 1));
$imagelink = intval($params->get( 'image_link', 0 ));
$categorylink = intval($params->get( 'category_link', 0 ));

// SET LOCALE
if (($setlocaletimeto != NULL) && ($setlocaletimeto != "")) setlocale(LC_TIME, $setlocaletimeto);

// VARIABLES STATIQUES
$com_dg = "com_datsogallery";
$func_detail = "detail";
$func_category = "viewcategory";
$theend = "...";

$content = '<table width="100%" border="0" cellspacing="0" cellpadding="0" align="center">';

// FORCER $max A 5 SI PAS DEFINI
if ($max == "" || $max == NULL) $max = 5;

// RECUPERATION DES COMMENTAIRES
$database->setQuery("SELECT com.cmtid as commentid, com.cmtpic as imageid, com.cmtname as name, com.cmttext as text, com.cmtdate as date, cat.cid as categoryid, cat.name as category, dg.imgtitle as image, dg.imgauthor as author, dg.imgcounter as hits, dg.imgvotes as votes, usr.username as username"
. "\n FROM #__datsogallery_comments com "
. "\n JOIN #__datsogallery dg ON com.cmtpic =dg.id "
. "\n JOIN #__datsogallery_catg cat ON cat.cid = dg.catid "
. "\n LEFT OUTER JOIN #__users usr ON BINARY com.cmtname = BINARY usr.name "
. "\n WHERE com.published = '1' "
. "\n ORDER BY cmtdate DESC "
. "\n LIMIT ".$number);
$comments = $database->loadObjectList();

// SI IL N'Y A PAS DE COMMENTAIRES
if ((count($comments)) == '0') {
	if ($nocomment == "" || $nocomment == NULL) $nocomment = "Pas de commentaire";
	$content .= "<tr><td class='mod_dg_latest_nocomments'>" . $nocomment . "</td></tr>\n";
	$content .="</table>\n";
	return $content;
	}

// RECUPERATION DE L'ITEM DU MENU VERS COM_DATSOGALLERY
$database->setQuery("SELECT id FROM #__menu WHERE link='index.php?option=com_datsogallery'");
$itemid = $database->loadObjectList();
$itemid = $itemid[0]->id;

// ON TRANSFORME LE TEMPLATE EN EXPRESSION PHP
$defaultfFormatStr= '${date(%d %B, %Y @%H:%M)} :<br />${text} by <b>${name}</b><br /><br />';
//$defaultfFormatStr= '${date(%d %B, %Y @%H:%M)} :<br />${text} commentaire de <b>${name}</b> sur le slide <u>${image}</u> (categorie : <i>${category}</i>)<br /><br />';
if(($customFormatStr == NULL) || ($customFormatStr == "")) $customFormatStr = $defaultfFormatStr;
	else {
        $customFormatStr = preg_replace('/^"(.*)"$/', "\$1", $customFormatStr);
        $customFormatStr = preg_replace("/^'(.*)'$/", "\$1", $customFormatStr);
        // escape all " within the string
        $customFormatStr = preg_replace('/"/','\"', $customFormatStr);
        }
        
$customFormat=$customFormatStr;
$evalString = '"';
		
while(preg_match('/\$\{(name|text|date|category|image|author|hits|votes|username)(\(([^\)]*)\))?[\t ]*\}(.*)$/',$customFormat,$matches)){
	$evalString .= substr($customFormat,0,strpos($customFormat,$matches[0]));

	switch ($matches[1]){
		case 'date':
			if (!isset($matches[3]) || $matches[3] == ''){ //PAS DE FORMAT DE DATE SPECIFIE
				if($mosConfig_lang == 'english'){
					$dateFormat = "'D, M jS, Y, @g:ia'";
					$evalString .= '". date('.$dateFormat.',$comment->'.$matches[1].')."';
				} else {
					$dateFormat = "'%a %b %d, %Y @%I:%M%p'";
					$evalString .= '". strftime('.$dateFormat.',$comment->'.$matches[1].')."';
				}
			} else { //FORMAT DE DATE SPECIFIE DANS LE TEMPLATE
				$matches[3] = trim($matches[3]);
				// make sure the date format specifiers are surrounded by quotes
				if(!(preg_match('/^\'.*\'$/', $matches[3]) || preg_match('/^".*"$/', $matches[3])))
					$matches[3] = "'".$matches[3]."'";
					// SI UN 'SYMBOLE %' EST TROUVE ALORS LA FONCTION strftime() EST UTILISE
					if(preg_match("/\%/", $matches[3])) $evalString .= '". strftime('.$matches[3].', $comment->'.$matches[1].')."';
					// SINON C'EST LA FONCTION date() QUI EST UTILISEE
					else $evalString .= '".date('.$matches[3].', $comment->'.$matches[1].')."';
			}
		break;

		case 'text':
			if ($textlink) {
				$url = "index.php?option=".$com_dg."&amp;func=".$func_detail."&amp;Itemid=".$itemid.'&amp;id=".$comment->imageid."&amp;catid=".$comment->categoryid."';
				$url = sefRelToAbs($url);
				$evalString .= "<a href=".$url.">";
				$evalString .= '".substr($comment->text,0,$max)." ...';
				$evalString .= '</a>';
			} else {
				$evalString .= '".$comment->text."';
			}
		break;

		case 'category':
			if ($categorylink) {
				$url = "index.php?option=".$com_dg."&amp;func=".$func_category."&amp;Itemid=".$itemid.'&amp;catid=".$comment->categoryid."';
				$url = sefRelToAbs($url);
				$evalString .= "<a href=".$url.">";
				$evalString .= '".$comment->category."';
				$evalString .= '</a>';
			} else {
				$evalString .= '".$comment->category."';
			}
		break;

		case 'image':
			if ($imagelink) {
				$url = "index.php?option=".$com_dg."&amp;func=".$func_detail."&amp;Itemid=".$itemid.'&amp;id=".$comment->imageid."&amp;catid=".$comment->categoryid."';
				$url = sefRelToAbs($url);
				$evalString .= "<a href=".$url.">";
				$evalString .= '".$comment->image."';
				$evalString .= '</a>';
			} else {
				$evalString .= '".$comment->image."';
			}
		break;
		
		case 'author':
			$evalString .= '".$comment->author."';
		break;
		
		case 'hits':
			$evalString .= '".$comment->hits."';
		break;
		
		case 'votes':
			$evalString .= '".$comment->votes."';
		break;
		
		case 'username':
			$evalString .= '".$comment->username."';
		break;
		
		case 'name':
			$evalString .= '".$comment->name."';
		break;
		
		default:
		break;
		}
		$customFormat = $matches[4];
	}

	$evalString .= $customFormat. '"';

//TRAITEMENT DES COMMENTAIRES
$firstTime=true;

foreach ($comments as $comment) {
    if($firstTime) $content .= "<tr><td class='mod_dg_latestcomments_first'>";
    else $content .= "<tr><td class='mod_dg_latestcomments'>";
    $eventStr = "";
    eval('$eventStr = '.$evalString.";");
    $content .= $eventStr."</td></tr>\n";
    $firstTime=false;
}

$content .="</table>\n";
return $content;

?>
