<?php
	
	/*************************************************\
	*    Search Mambot for DatsoGallery 1.3.9.x      **
	*    By         : Andrey Datso                   **
	*    Version    : 1.3                            **
	*    Homepage   : http://www.datso.fr            **
	*    Released Under GNU GPL Public License       **
	\*************************************************/
	
	defined( '_VALID_MOS' ) or die( 'Restricted access' );

	$_MAMBOTS->registerFunction( 'onSearch', 'SDG' );

	function SDG( $text, $ordering='' ) {
	global $database, $my, $mosConfig_live_site, $catlink, $mosConfig_lang, $mosConfig_absolute_path;

    if (file_exists($mosConfig_absolute_path . '/components/com_datsogallery/language/' . $mosConfig_lang . '.php')) {
    require_once($mosConfig_absolute_path . '/components/com_datsogallery/language/' . $mosConfig_lang . '.php');
	} else {
	require_once($mosConfig_absolute_path . '/components/com_datsogallery/language/english.php');
	}

	$text = trim( $text );
	if ($text == '') {
	return array();
	}

	$section = " DatsoGallery : ";
	$wheres = array();
	$wheres2 = array();
	$wheres2[] = "b.imgtitle LIKE '%$text%'";
	$wheres2[] = "b.imgtext LIKE '%$text%'";
	$where = '(' . implode( ') OR (', $wheres2 ) . ')';

	switch ( $ordering ) {
	case 'oldest':
	$order = 'b.imgdate ASC';
	break;
	case 'popular':
	$order = 'b.imgcounter DESC';
	break;
	case 'category':
	$order = 'bc.name ASC, b.imgtitle ASC';
	break;
	case 'newest':
	$order = 'b.imgdate DESC';
	break;
	case 'alpha':
	default:
	$order = 'b.imgtitle ASC';
	}

    $query1 = "SELECT id, name"
	."\n FROM #__menu"
	."\n WHERE link = 'index.php?option=com_datsogallery'";
    $database->setQuery($query1);
    $rows = $database->loadObjectList();
    $dgname = ' ' . $rows[0]->name . ' : ';
    if (isset($rows[0]->id)) {
    $Itemid = $rows[0]->id;
    } else {
    $Itemid = "";
    }

	$query = " SELECT b.*, b.imgtitle AS title, b.imgtext "
	. " AS text, b.imgdate "
	. " AS created, CONCAT( '$dgname', bc.name,'&nbsp;' ) "
	. " AS section, b.id AS id "
	. " FROM #__datsogallery_catg AS bc "
	. " LEFT JOIN #__datsogallery AS b ON b.catid = bc.cid "
	. " WHERE $where "
	. " AND (b.published=1 AND b.approved=1) "
	. " AND (bc.published=1 AND bc.access<=$my->gid) "
	. " ORDER BY $order ";
	$database->setQuery( $query );
	$rows = $database->loadObjectList();

	for ($i=0; $i<count($rows); $i++)  {
	$row = &$rows[$i];
	$url = "index.php?option=com_datsogallery&func=detail&Itemid=$Itemid&catid=$row->catid&id=$row->id";
	$row->href = $url;
	$row->created = _DG_DATE_ADD . " : " . strftime( "%c", $row->created );
	}
	return $rows;
	}
?>
